# Zig LeapC Examples

Trying to use LeapC in Zig

## How to build

```
zig build
```

The resulting executable(s) will be found in `zig-cache/bin`. On Windows, you will need to copy `LeapC.dll` to the resulting folder.

## Changes to LeapC's header

Because Zig's translate-c doesn't support `pragma pack` yet, and LeapC uses an alignment of 1 on all the data, we had to find which data was misaligned when pulling events. To do that, we wrote a C program that displays the size of a type, and made the same in Zig. By comparing the different types sizes, we can find which structure might miss alignment. Then by trial and error, adding `align(1)` to different fields, we can find the proper alignment and fix it.

Here is a list of fixes that were found during this "research":

* Set `align(1)` on `LEAP_HAND`'s `visible_time`
* Set `align(1)` on `LEAP_TRACKING_EVENT`'s `pHands`
* Set `align(1)` on `LEAP_IMAGE`'s `properties`

These fixes are automatically by the build system.

In the future, this header fix/generation will be put in a separate repository so it can be pulled more easily for any project.